Description

If you have DHCP in failover mode, the OMAPI lease creation doesn't take effect on the second one.  If it'd be possible to push to 

both this would be a great workaround - but I appreciate that the number of use cases is pretty darn small :-)

History

#1 - 07/17/2013 10:07 AM - Ohad Levy

is there another format that we need to let omapi that there is a secondary server? do you happen to know if that works?

#2 - 07/17/2013 10:46 AM - Adrian Bridgett

Hi Ohad, I'm not aware of one.  The internet is thin on the ground in terms of info but OMAPI and ISC DHCP server doesn't seem to propagate the

lease from one to the other.  So basically we just need the ability to say "please push the lease to a list of DHCP servers rather than just one" and

then it can iterate over it.

#3 - 07/17/2013 12:38 PM - Dominic Cleal

- Category set to DHCP

#4 - 12/26/2013 11:48 PM - David Swift

For what it is worth, the research I did indicates that any host leases added via OMAPI will not be picked up by the failover built into isc-dhcp-server. 

The only definitive statement I see about OMAPI not updating secondaries is from 2001, but I have not found anything to indicate that that situation

has changed.

I may try to implement this for us, by the following:

adding a 'dhcp_secondary' field to the settings file.  This field would only be defined on the primary smart-proxy.

allowing the write to the secondary to fail, without stopping the entire orchestration, to allow for the secondary smart-proxy to be offline.

Provide an API script to execute a re-write of all host leases, so that the primary and secondary can be synchronized in the event one or the

other goes offline.

Does that make sense?  Have you guys heard of other ideas?

#5 - 01/28/2015 06:35 PM - Tom Downes

I'm trying to do something similar. I think the issue is that host declarations are not part of the DHCP failover peer scheme and not a problem with

OMAPI per se.

In DNS-land, I can setup a true slave that automatically receives updates from the DNS master that is OMAPI-controlled by Foreman. The secondary

doesn't know anything about OMAPI or Foreman. DHCP's peer failover is more like load balancing (with 100/0 when one fails) and only works on the

pool of leases without "fixed-address".

Like David, I can find mentions of a desire for fixed-address failover going a while back. It seems that among the issues is that failover is an RFC spec

and OMAPI is implementation specific:

http://permalink.gmane.org/gmane.network.dhcp.isc.dhcp-server/8197

I like David's suggestion. Another alternative might be to avoid OMAPI altogether for the creation of fixed-address hosts (you might still issue

read-only queries via OMAPI). i.e., create static file to be "include"d by dhcpd.conf and then provide something like a post-commit hook to sync it

atomically to another server.
#6 - 08/06/2016 06:27 AM - Yama Kasi

What is the status of this ?

I'm facing the same issue again as I also tried before to figure out a way, I was even thinking about sycing the leasefile.

Any update on this would be great, I discussed it in the ISC-DHCP channel but we didn't find any possible way which would work this way.

A static included file (and sync that) would be best.

#7 - 08/15/2016 09:07 AM - Yama Kasi

I have discussed this again with the ISC-DHCP guys and as there is no sync between the static leases we simply can do a second omapi call to the

secondary server so both lease files will be the same when adding/editing/changing a host.

I would like to test this by adding the second omapi call manually to the code, would this be possible ?

#8 - 05/24/2018 10:54 AM - Geoff Gatward

This feature seems to have dropped off the radar - has any more thought been given to this functionality?  I have a couple of large installations using

Foreman that are introducing the requirement for redundancy in the DHCP infrastructure...  having DHCP failover is important in enterprise

installations.

#9 - 05/25/2018 11:43 AM - Marek Hulán

You might be interested in https://community.theforeman.org/t/highly-available-smart-proxies-part-2/8299/40 and 

https://community.theforeman.org/t/user-survey-supporting-ha-smart-proxies/8832
